# Reference Clock Commands and Options

| Master Time Facility at the UDel Internet Research Laboratory

## 1. Related Links

### 1.1. Reference Clock Support

- External Clock Discipline and the Local Clock Driver

- How to Write a Reference Clock Driver

- How to build new generic clocks

- Reference Clock Drivers

- local

- spectracom

- truetime

- generic

- arbiter

- modem

- nmea

- pps

- hpgps

- shm

- trimble

- oncore

- jjy

- zyfer

- gpsd === Reference Clock Commands and Options

- refclock - specify reference clock server

- options - specify clock-driver options

- Command Index

## 2. Reference Clock Types

Unless noted otherwise, further information about these types is on the Reference Clock Support page.

## 3. Commands and Options

`refclock` drivername [`unit` u] [`prefer`] [`subtype` int] [`mode` int] [`minpoll` int] [`maxpoll` int] [`time1` sec] [`time2` sec] [`stratum` int] [`refid` string] [`path` filename] [`ppspath` filename] [`baud` number] [`flag1` {`0` | `1`}] [`flag2` {`0` | `1`}] [`flag3` {`0` | `1`}] [`flag4` {`0` | `1`}]

  This command is used to configure reference clocks. The required drivername argument is the shortname of a driver type (e.g., `shm`, `nmea`, `generic`; see the Reference Clock Drivers page for a full list. The options are interpreted as follows:

  `unit`

    The 0-origin unit number of the device; this modifies the devicename. If not specified, defaults to zero.

  `prefer`

    Marks the reference clock as preferred. All other things being equal, this host will be chosen for synchronization among a set of correctly operating hosts and clocks. See the "Mitigation Rules and the prefer Keyword" page (available as part of the HTML documentation provided in `/usr/share/doc/ntp`) for further information.

  `subtype` int

    Some drivers (notably the generic and jjy drivers) support multiple device types. This option selects among them in a driver-dependent way.

  `mode` int

    Specifies a mode number which is interpreted in a device-specific fashion. For instance, it selects a dialing protocol in the ACTS driver and a sentence mix in the nmea driver.

  `minpoll` int; `maxpoll` int

    These options specify the minimum and maximum polling interval for reference clock messages, as a power of 2 in seconds. For most directly connected reference clocks, both minpoll and maxpoll default to 6 (64 sec). For modem reference clocks, minpoll defaults to 10 (17.1 min) and maxpoll defaults to 14 (4.5 hours). The allowable range is 0 (1 sec) to 17 (36.4 hours) inclusive.

  `time1` sec

    Specifies a constant to be added to the time offset produced by the driver, a fixed-point decimal number in seconds. Each "g" on the end of the constant adds the number of seconds in a 10-bit GPS era; each "G" adds the number of seconds in a 13-bit GPS era. This is used as a calibration constant to adjust the nominal time offset of a particular clock to agree with an external standard, such as a precision PPS signal. It also provides a way to correct a systematic error or bias due to era wraparound from a GPS device, serial port or operating system latencies, different cable lengths or receiver internal delay. The specified offset is in addition to the propagation delay provided by other means, such as internal DIP switches. Where a calibration for an individual system and driver is available, an approximate correction is noted in the driver documentation pages. Note: To facilitate calibration when more than one radio clock or PPS signal is supported, a special calibration feature is available. It takes the form of an argument to the `enable` command described in "Miscellaneous Options" page and operates as described in the "Reference Clock Drivers" page.

  `time2` secs

    Specifies a fixed-point decimal number in seconds, which is interpreted in a driver-dependent way. See the descriptions of specific drivers in the "Reference Clock Drivers" page.

  `stratum` int

    Specifies the stratum number assigned to the driver, an integer between 0 and 15. This number overrides the default stratum number ordinarily assigned by the driver itself, usually zero.

  `refid` string

    Specifies an ASCII string of from one to four characters which defines the reference identifier used by the driver. This string overrides the default identifier ordinarily assigned by the driver itself.

  `path` filepath

    Overrides the default device location for this refclock.

  `ppspath` filepath

    Overrides the default PPS device location (if any) for this driver.

  `baud` number

    Overrides the defaults baud rate for this driver.

  `flag1` `{0 | 1}`; `flag2` `{0 | 1}`; `flag3` `{0 | 1}`; `flag4` `{0 | 1}`

    These four flags are used for customizing the clock driver. The interpretation of these values, and whether they are used at all, is a function of the particular clock driver. However, by convention `flag4` is used to enable recording monitoring data to the clockstats file configured with the filegen command. Further information on the filegen command can be found in "Monitoring Options".

Home Page | Site Map | Contacts